#![feature(box_patterns, box_syntax)]
extern crate prusti_contracts;


struct List {
    val: i32,
    next: Option<Box<List>>
}

fn client(a: &mut List, b: &mut List) {
    let old_len = b.len();
    append(a, 100); 
    assert!(b.len() == old_len);
}
 






 


fn append(a: &mut List, v: i32) {
    if let Some(box ref mut tail) = a.next {
        append(tail, v); 
    } else {
        a.next = Some(box List {
            val: v,
            next: None
        });
    }
}




impl List {

    #[pure] // Prusti: can be used in specifications
    fn len(&self) -> usize {
      match self.next {
        None => 1,
        Some(box ref tail) => 1 + tail.len()
      }
    }

} 


