#![feature(box_patterns, box_syntax)]
extern crate prusti_contracts;


struct List {
    val: i32,
    next: Option<Box<List>>
}
  
// alternatively, replace this whole spec in the style of "sortedness preserved" (cf. append below)
#[requires="a.sorted() && a.get(a.len() - 1) <= 100"]
#[ensures="a.sorted()"]
fn client(a: &mut List, b: &mut List) {
    let old_len = b.len();
    append(a, 100); 
    assert!(b.len() == old_len);
}


impl List {
    #[pure]
    fn sorted(&self) -> bool {
      match self.next {
        None => true,
        Some(box ref tail) => self.val <= tail.val && tail.sorted()
      }
    }
}















































































































impl List {
    #[pure]
    #[ensures="result >= 0"]
    fn len(&self) -> usize {
        match self.next {
            None => 1,
            Some(box ref tail) => tail.len() + 1
        }
    }

    #[pure]
    #[requires="0 <= index && index < self.len()"]
    fn get(&self, index: usize) -> i32 {
        if index == 0 {
            self.val
        } else {
            if let Some(box ref tail) = self.next {
                tail.get(index - 1)
            } else {
                unreachable!()
            }
        }
    }
}

#[ensures="a.get(0) == old(a.get(0))"]
#[ensures="old(a.sorted()) ==> (old(a.get(a.len() - 1)) <= v ==> a.sorted())"] // sortedness preserved
fn append(a: &mut List, v: i32) {
    if let Some(box ref mut tail) = a.next {
        append(tail, v);
    } else {
        a.next = Some(box List {
            val: v,
            next: None
        });
    }
}
